Const ForReading = 1, ForWriting = 2, ForAppending = 8

On Error Resume Next

Dim Spn
Dim OutputDir
set wshArgs = WScript.Arguments
If wshArgs.Count <> 2 then
	WScript.Echo "Format: WScript spn.vbs <SPN> <OUTPUTDIR>"
	WScript.Quit
End If

Spn = wshArgs.Item(0)
OutputDir = wshArgs.Item(1)
'WScript.Echo Spn
'WScript.Echo OutputDir

Set fso = CreateObject("Scripting.FileSystemObject")
Set OutfileStream = fso.OpenTextFile(OutputDir & "\spn\spn.out", ForWriting, True)

if Not fso.FolderExists(OutputDir) then
	WScript.Quit
end if
if Err.Number <> 0 then
	WScript.Quit
end if

set dse = GetObject("LDAP://RootDSE")
if Err.Number <> 0 then
	OutfileStream.WriteLine("Error: Failed to GetObject: LDAP://RootDSE")
	OutfileStream.Close()
	WScript.Quit
end if

root = dse.Get("RootDomainNamingContext")

if Err.Number <> 0 then
	OutfileStream.WriteLine("Error: Failed to Get: RootDomainNamingContext")
	OutfileStream.Close()
	WScript.Quit
end if

adpath = "GC://" & root
base = "<" & adpath & ">"
Set conn = CreateObject("ADODB.Connection")
Set comm = CreateObject("ADODB.Command")
conn.Provider = "ADsDSOObject"
conn.Open "Active Directory Provider"
Set comm.ActiveConnection = conn
comm.Properties("Page Size") = 1000

comm.CommandText = base & ";(servicePrincipalName=" & spn & ");distinguishedName;subtree"

Set rs = comm.Execute
if Err.Number <> 0 then
	OutfileStream.WriteLine("Error: Failed to Execute ADO command")
	OutfileStream.Close()
	WScript.Quit
end if

OutfileStream.WriteLine("GET:" & spn)
Do Until rs.EOF
 cn = rs.Fields(0).Value
 OutfileStream.WriteLine(cn)
 rs.MoveNext
Loop
OutfileStream.Close()
